#include <stdio.h>

#include "xtext.h"

static char * xtext_color[] = {

"snow","ghost white","GhostWhite","white smoke",
"WhiteSmoke","gainsboro","floral white","FloralWhite",
"old lace","OldLace","linen","antique white",
"AntiqueWhite","papaya whip","PapayaWhip","blanched almond",
"BlanchedAlmond","bisque","peach puff","PeachPuff",
"navajo white","NavajoWhite","moccasin","cornsilk",
"ivory","lemon chiffon","LemonChiffon","seashell",
"honeydew","mint cream","MintCream","azure",
"alice blue","AliceBlue","lavender","lavender blush",
"LavenderBlush","misty rose","MistyRose","white",
"black","dark slate gray","DarkSlateGray","dark slate grey",
"DarkSlateGrey","dim gray","DimGray","dim grey",
"DimGrey","slate gray","SlateGray","slate grey",
"SlateGrey","light slate gray","LightSlateGray","light slate grey",
"LightSlateGrey","gray","grey","light grey",
"LightGrey","light gray","LightGray","midnight blue",
"MidnightBlue","navy","navy blue","NavyBlue",
"cornflower blue","CornflowerBlue","dark slate blue","DarkSlateBlue",
"slate blue","SlateBlue","medium slate blue","MediumSlateBlue",
"light slate blue","LightSlateBlue","medium blue","MediumBlue",
"royal blue","RoyalBlue","blue","dodger blue",
"DodgerBlue","deep sky blue","DeepSkyBlue","sky blue",
"SkyBlue","light sky blue","LightSkyBlue","steel blue",
"SteelBlue","light steel blue","LightSteelBlue","light blue",
"LightBlue","powder blue","PowderBlue","pale turquoise",
"PaleTurquoise","dark turquoise","DarkTurquoise","medium turquoise",
"MediumTurquoise","turquoise","cyan","light cyan",
"LightCyan","cadet blue","CadetBlue","medium aquamarine",
"MediumAquamarine","aquamarine","dark green","DarkGreen",
"dark olive green","DarkOliveGreen","dark sea green","DarkSeaGreen",
"sea green","SeaGreen","medium sea green","MediumSeaGreen",
"light sea green","LightSeaGreen","pale green","PaleGreen",
"spring green","SpringGreen","lawn green","LawnGreen",
"green","chartreuse","medium spring green","MediumSpringGreen",
"green yellow","GreenYellow","lime green","LimeGreen",
"yellow green","YellowGreen","forest green","ForestGreen",
"olive drab","OliveDrab","dark khaki","DarkKhaki",
"khaki","pale goldenrod","PaleGoldenrod","light goldenrod yellow",
"LightGoldenrodYellow","light yellow","LightYellow","yellow",
"gold","light goldenrod","LightGoldenrod","goldenrod",
"dark goldenrod","DarkGoldenrod","rosy brown","RosyBrown",
"indian red","IndianRed","saddle brown","SaddleBrown",
"sienna","peru","burlywood","beige",
"wheat","sandy brown","SandyBrown","tan",
"chocolate","firebrick","brown","dark salmon",
"DarkSalmon","salmon","light salmon","LightSalmon",
"orange","dark orange","DarkOrange","coral",
"light coral","LightCoral","tomato","orange red",
"OrangeRed","red","hot pink","HotPink",
"deep pink","DeepPink","pink","light pink",
"LightPink","pale violet red","PaleVioletRed","maroon",
"medium violet red","MediumVioletRed","violet red","VioletRed",
"magenta","violet","plum","orchid",
"medium orchid","MediumOrchid","dark orchid","DarkOrchid",
"dark violet","DarkViolet","blue violet","BlueViolet",
"purple","medium purple","MediumPurple","thistle",
"snow1","snow2","snow3","snow4",
"seashell1","seashell2","seashell3","seashell4",
"AntiqueWhite1","AntiqueWhite2","AntiqueWhite3","AntiqueWhite4",
"bisque1","bisque2","bisque3","bisque4",
"PeachPuff1","PeachPuff2","PeachPuff3","PeachPuff4",
"NavajoWhite1","NavajoWhite2","NavajoWhite3","NavajoWhite4",
"LemonChiffon1","LemonChiffon2","LemonChiffon3","LemonChiffon4",
"cornsilk1","cornsilk2","cornsilk3","cornsilk4",
"ivory1","ivory2","ivory3","ivory4",
"honeydew1","honeydew2","honeydew3","honeydew4",
"LavenderBlush1","LavenderBlush2","LavenderBlush3","LavenderBlush4",
"MistyRose1","MistyRose2","MistyRose3","MistyRose4",
"azure1","azure2","azure3","azure4",
"SlateBlue1","SlateBlue2","SlateBlue3","SlateBlue4",
"RoyalBlue1","RoyalBlue2","RoyalBlue3","RoyalBlue4",
"blue1","blue2","blue3","blue4",
"DodgerBlue1","DodgerBlue2","DodgerBlue3","DodgerBlue4",
"SteelBlue1","SteelBlue2","SteelBlue3","SteelBlue4",
"DeepSkyBlue1","DeepSkyBlue2","DeepSkyBlue3","DeepSkyBlue4",
"SkyBlue1","SkyBlue2","SkyBlue3","SkyBlue4",
"LightSkyBlue1","LightSkyBlue2","LightSkyBlue3","LightSkyBlue4",
"SlateGray1","SlateGray2","SlateGray3","SlateGray4",
"LightSteelBlue1","LightSteelBlue2","LightSteelBlue3","LightSteelBlue4",
"LightBlue1","LightBlue2","LightBlue3","LightBlue4",
"LightCyan1","LightCyan2","LightCyan3","LightCyan4",
"PaleTurquoise1","PaleTurquoise2","PaleTurquoise3","PaleTurquoise4",
"CadetBlue1","CadetBlue2","CadetBlue3","CadetBlue4",
"turquoise1","turquoise2","turquoise3","turquoise4",
"cyan1","cyan2","cyan3","cyan4",
"DarkSlateGray1","DarkSlateGray2","DarkSlateGray3","DarkSlateGray4",
"aquamarine1","aquamarine2","aquamarine3","aquamarine4",
"DarkSeaGreen1","DarkSeaGreen2","DarkSeaGreen3","DarkSeaGreen4",
"SeaGreen1","SeaGreen2","SeaGreen3","SeaGreen4",
"PaleGreen1","PaleGreen2","PaleGreen3","PaleGreen4",
"SpringGreen1","SpringGreen2","SpringGreen3","SpringGreen4",
"green1","green2","green3","green4",
"chartreuse1","chartreuse2","chartreuse3","chartreuse4",
"OliveDrab1","OliveDrab2","OliveDrab3","OliveDrab4",
"DarkOliveGreen1","DarkOliveGreen2","DarkOliveGreen3","DarkOliveGreen4",
"khaki1","khaki2","khaki3","khaki4",
"LightGoldenrod1","LightGoldenrod2","LightGoldenrod3","LightGoldenrod4",
"LightYellow1","LightYellow2","LightYellow3","LightYellow4",
"yellow1","yellow2","yellow3","yellow4",
"gold1","gold2","gold3","gold4",
"goldenrod1","goldenrod2","goldenrod3","goldenrod4",
"DarkGoldenrod1","DarkGoldenrod2","DarkGoldenrod3","DarkGoldenrod4",
"RosyBrown1","RosyBrown2","RosyBrown3","RosyBrown4",
"IndianRed1","IndianRed2","IndianRed3","IndianRed4",
"sienna1","sienna2","sienna3","sienna4",
"burlywood1","burlywood2","burlywood3","burlywood4",
"wheat1","wheat2","wheat3","wheat4",
"tan1","tan2","tan3","tan4",
"chocolate1","chocolate2","chocolate3","chocolate4",
"firebrick1","firebrick2","firebrick3","firebrick4",
"brown1","brown2","brown3","brown4",
"salmon1","salmon2","salmon3","salmon4",
"LightSalmon1","LightSalmon2","LightSalmon3","LightSalmon4",
"orange1","orange2","orange3","orange4",
"DarkOrange1","DarkOrange2","DarkOrange3","DarkOrange4",
"coral1","coral2","coral3","coral4",
"tomato1","tomato2","tomato3","tomato4",
"OrangeRed1","OrangeRed2","OrangeRed3","OrangeRed4",
"red1","red2","red3","red4",
"DeepPink1","DeepPink2","DeepPink3","DeepPink4",
"HotPink1","HotPink2","HotPink3","HotPink4",
"pink1","pink2","pink3","pink4",
"LightPink1","LightPink2","LightPink3","LightPink4",
"PaleVioletRed1","PaleVioletRed2","PaleVioletRed3","PaleVioletRed4",
"maroon1","maroon2","maroon3","maroon4",
"VioletRed1","VioletRed2","VioletRed3","VioletRed4",
"magenta1","magenta2","magenta3","magenta4",
"orchid1","orchid2","orchid3","orchid4",
"plum1","plum2","plum3","plum4",
"MediumOrchid1","MediumOrchid2","MediumOrchid3","MediumOrchid4",
"DarkOrchid1","DarkOrchid2","DarkOrchid3","DarkOrchid4",
"purple1","purple2","purple3","purple4",
"MediumPurple1","MediumPurple2","MediumPurple3","MediumPurple4",
"thistle1","thistle2","thistle3","thistle4",
"gray0","grey0","gray1","grey1",
"gray2","grey2","gray3","grey3",
"gray4","grey4","gray5","grey5",
"gray6","grey6","gray7","grey7",
"gray8","grey8","gray9","grey9",
"gray10","grey10","gray11","grey11",
"gray12","grey12","gray13","grey13",
"gray14","grey14","gray15","grey15",
"gray16","grey16","gray17","grey17",
"gray18","grey18","gray19","grey19",
"gray20","grey20","gray21","grey21",
"gray22","grey22","gray23","grey23",
"gray24","grey24","gray25","grey25",
"gray26","grey26","gray27","grey27",
"gray28","grey28","gray29","grey29",
"gray30","grey30","gray31","grey31",
"gray32","grey32","gray33","grey33",
"gray34","grey34","gray35","grey35",
"gray36","grey36","gray37","grey37",
"gray38","grey38","gray39","grey39",
"gray40","grey40","gray41","grey41",
"gray42","grey42","gray43","grey43",
"gray44","grey44","gray45","grey45",
"gray46","grey46","gray47","grey47",
"gray48","grey48","gray49","grey49",
"gray50","grey50","gray51","grey51",
"gray52","grey52","gray53","grey53",
"gray54","grey54","gray55","grey55",
"gray56","grey56","gray57","grey57",
"gray58","grey58","gray59","grey59",
"gray60","grey60","gray61","grey61",
"gray62","grey62","gray63","grey63",
"gray64","grey64","gray65","grey65",
"gray66","grey66","gray67","grey67",
"gray68","grey68","gray69","grey69",
"gray70","grey70","gray71","grey71",
"gray72","grey72","gray73","grey73",
"gray74","grey74","gray75","grey75",
"gray76","grey76","gray77","grey77",
"gray78","grey78","gray79","grey79",
"gray80","grey80","gray81","grey81",
"gray82","grey82","gray83","grey83",
"gray84","grey84","gray85","grey85",
"gray86","grey86","gray87","grey87",
"gray88","grey88","gray89","grey89",
"gray90","grey90","gray91","grey91",
"gray92","grey92","gray93","grey93",
"gray94","grey94","gray95","grey95",
"gray96","grey96","gray97","grey97",
"gray98","grey98","gray99","grey99",
"gray100","grey100","dark grey","DarkGrey",
"dark gray","DarkGray","dark blue","DarkBlue",
"dark cyan","DarkCyan","dark magenta","DarkMagenta",
"dark red","DarkRed","light green","LightGreen",
NULL

};

static char *xtext_key[] = {

"Up","Down","Right","Left","space","Tab","Return",
"a","b","c","d","e","f","g","h","i","j","k","l","m","n",
"o","p","q","r","s","t","u","v","w","x","y","z",
"1","2","3","4","5","6","7","8","9","0",NULL

};

static char *xtext_num[] = {

"0 (off)","1 (on)","2","3","4","5","6","7","8","9",
"10","11","12","13","14","15","16","17","18","19",
"20","21","22","23","24","25","26","27","28","29",
"30","35","40","45","50","60","70","80","90",NULL

};

static char *xtext_pixel[] = {

"*","5","6","7","8","9",
"10","11","12","13","14","15","16","17","18","19",
"20","21","22","23","24","25","26","27","28","29",
"30","31","32","33","34","35","36","37","38","39",
"40","45","50","60","65","70","75","80","85","90",
NULL

};
static char *xtext_point[] = {

"*","20","50","60","70","80","90","100",
"110","120","130","140","150","160","170","180","190","200",
"230","240","250","300","1000",
NULL

};

static char *xtext_res[] = {

"*","72","75","90","100",NULL

};

typedef struct {
	int point[7];
}font_select_t;

static char *message = "[Up-Down] Move, [Enter] Select, [q] Cancel";
static char *message_font = "[Tab] Foucus_Move [Up-Down] Move, [Enter] Select, [q] Cancel";

static int TRUE_TYPE = 0;

static xtext_font_t * _font_match(xtext_font_t *head,char *name,int n)
{
	xtext_font_t *xfd;
	int i;

	if(head == NULL ) return NULL;

	for(xfd=head,i=0;xfd!=NULL;xfd=xfd->next,i++){

		if(i == n){
			strcpy(name,xfd->name);
			return xfd;
		}
	}

	return NULL;
}
static int _get_font_data(	xtext_font_t *head,
				char *fnd,
				char *fmy,
				char *other,
				char *pixel,
				char *point,
				char *xres,
				char *yres,
				font_select_t fsel	)
{
	xtext_font_t *xfd;
	int i;

	if((xfd = _font_match(head,fnd,fsel.point[0])) == NULL) return -1;

	if((xfd = _font_match(xfd->head,fmy,fsel.point[1])) == NULL) return -1;

	if((xfd = _font_match(xfd->head,other,fsel.point[2])) == NULL) return -1;

	if(xtext_pixel[fsel.point[3]] == NULL) return -1;
	strcpy(pixel,xtext_pixel[fsel.point[3]]);

	if(xtext_point[fsel.point[4]] == NULL) return -1;
	strcpy(point,xtext_point[fsel.point[4]]);

	if(xtext_res[fsel.point[5]] == NULL) return -1;
	strcpy(xres,xtext_res[fsel.point[5]]);

	if(xtext_res[fsel.point[6]] == NULL) return -1;
	strcpy(yres,xtext_res[fsel.point[6]]);

	return 0;
}
static int _set_font_no(font_select_t *fsel,int fw)
{
	int i;

	for(i=fw+1;i<7;i++){
		fsel->point[i] = 0;
	}

	return 0;
}
static int _set_font_point(char *other,char *point,int no)
{
	char *p,*p1,temp[80];
	int i,c,f;

	i = 0;
	c = 0;
	f = 0;
	for(p=other;*p;p++){
		if(*p == '-'){
			c++;
		       	if(c == no){
				temp[i++] = *p;
				for(p1=point;*p1;p1++){
					temp[i++] = *p1;
				}
			       	f = 1;
		       	}else if(c == (no+1)){
				f = 0;
			}
		}
		if(f == 0) temp[i++] = *p;
	}
	temp[i] = '\0';

	strcpy(other,temp);

	return 0;
}
static int _get_font_select(char *string,xtext_font_t *head,font_select_t fsel)
{
	char fnd[50],fmy[50],other[80],pixel[10],point[10],xres[10],yres[10];
	char *p;
	int i;

	_get_font_data(head,fnd,fmy,other,pixel,point,xres,yres,fsel);

	if(TRUE_TYPE > 0){
		for(i=0;i<TRUE_TYPE;i++){
			if(i == 0){
				p = pixel;
			}else if(i == 1){
				p = point;
			}else if(i == 2){
				p = xres;
			}else if(i == 3){
				p = yres;
			}
			_set_font_point(other,p,i+5);
		}
	}

	sprintf(string,"-%s-%s%s",fnd,fmy,other);

	return 0;
}
static int _check_font_truetype(char *other)
{
	char *p,*pp = NULL;
	int flag;

	flag = 0;
	for(p=other;*p;p++){
		if(*p == '-'){
			if(++flag == 2){pp = p; break;}
		}else{
			flag = 0;
		}
	}
	if(pp == NULL) return 0;

	flag = 0;
	if(*(pp+1) == '0')
		flag++;
	else
		return 0;

	if(*(pp+3) == '0')
		flag++;
	else
		return flag;

	if(*(pp+5) == '0')
		flag++;
	else
		return flag;

	if(*(pp+7) == '0')
		flag++;
	else
		return flag;


	return flag;
}
static int _draw_window_font(	Display *disp,
				Window win,
				GC gc,
				GC color_gc,
				XFontStruct *fs,
				XFontStruct *fs_s,
				int width,
				int height,
				xtext_font_t *f_head,
				font_select_t fsel,
				int fw			)
{
	XCharStruct cs;
	int dir,as,ds;
	int x,y,w,h,h_0,len;
	int i,on;

	char temp[50],fnd[50],fmy[50],other[80],pixel[10],point[10],xres[10],yres[10];

	if(_get_font_data(f_head,fnd,fmy,other,pixel,point,xres,yres,fsel) < 0) return 0;

	TRUE_TYPE = _check_font_truetype(other);


	XClearWindow(disp,win);

	len = strlen(message_font);
	XTextExtents(fs,message_font,len,&dir,&as,&ds,&cs);
	w = cs.rbearing - cs.lbearing;
	h = cs.ascent + cs.descent;
	x = (width - w)/2;
	y = h+2;
	XDrawString(disp,win,gc,x,y,message_font,strlen(message_font));

	h_0 = height/2;

	sprintf(temp,"-%s",fnd);
	len = strlen(temp);
	XTextExtents(fs_s,temp,len,&dir,&as,&ds,&cs);
	w = cs.rbearing - cs.lbearing;
	h = cs.ascent + cs.descent;

	x = 2;
	y = h_0 + h;

	XDrawString(disp,win,color_gc,x,y,"-",1);
	if(fw == 0){
		XDrawImageString(disp,win,color_gc,x+7,y,temp+1,len-1);
	}else{
		XDrawString(disp,win,color_gc,x+7,y,temp+1,len-1);
	}

	x = x + w + 1;

	sprintf(temp,"-%s",fmy);
	len = strlen(temp);
	XTextExtents(fs_s,temp,len,&dir,&as,&ds,&cs);
	w = cs.rbearing - cs.lbearing;

	XDrawString(disp,win,color_gc,x,y,"-",1);
	if(fw == 1)
		XDrawImageString(disp,win,color_gc,x+7,y,temp+1,len-1);
	else
		XDrawString(disp,win,color_gc,x+7,y,temp+1,len-1);
	x = x + w + 1;

	len = strlen(other);
	XTextExtents(fs_s,other,len,&dir,&as,&ds,&cs);
	w = cs.rbearing - cs.lbearing;

	if(fw == 2)
		XDrawImageString(disp,win,color_gc,x,y,other,len);
	else
		XDrawString(disp,win,color_gc,x,y,other,len);


	x = 10;
	y = y + h + 10;
	for(i=0;i<TRUE_TYPE;i++){
		on = 0;
		if(i == 0){
			strcpy(temp,"TrueType ->");
			len = strlen(temp);
			XTextExtents(fs_s,temp,len,&dir,&as,&ds,&cs);
			w = cs.rbearing - cs.lbearing;
			XDrawString(disp,win,color_gc,x,y,temp,len);
			x = x + w + 10;

			sprintf(temp,"pix_size( %s )",pixel);
			if(fw == 3) on = 1;

		}else if(i == 1){
			sprintf(temp,"pnt_size( %s )",point);
			if(fw == 4) on = 1;

		}else if(i == 2){
			sprintf(temp,"x_res( %s )",xres);
			if(fw == 5) on = 1;

		}else if(i == 3){
			sprintf(temp,"y_res( %s )",yres);
			if(fw == 6) on = 1;
		}

		len = strlen(temp);
		XTextExtents(fs_s,temp,len,&dir,&as,&ds,&cs);
		w = cs.rbearing - cs.lbearing;

		if(on)
			XDrawImageString(disp,win,color_gc,x,y,temp,len);
		else
			XDrawString(disp,win,color_gc,x,y,temp,len);
		x = x + w + 5;
	}

	return 1;

}
static void _draw_window(	Display *disp,
				Window win,
				GC gc,
				GC color_gc,
				Colormap cmap,
				XFontStruct *fs,
				int width,
				int height,
				int color_no,
				int type		)
{
	XCharStruct cs;
	int dir,as,ds;

	int x,y,w,h,len;

	if(type == XJP_COL){
		if(xtext_color[color_no] == NULL) return;
	}else if(type == XJP_CHA){
		if(xtext_key[color_no] == NULL) return;
	}

	XClearWindow(disp,win);

	len = strlen(message);
	XTextExtents(fs,message,len,&dir,&as,&ds,&cs);
	w = cs.rbearing - cs.lbearing;
	h = cs.ascent + cs.descent;
	x = (width - w)/2;
	y = h+2;
	XDrawString(disp,win,gc,x,y,message,strlen(message));

	if(type == XJP_COL){
		XColor g0,g1;

		XAllocNamedColor(disp,cmap,xtext_color[color_no],&g1,&g0);
		XSetForeground(disp,color_gc,g1.pixel);

		x = ((width*2 - width)/4)/2;
		y = y+5;
		w = width/4;
		h = height/2;
		XFillRectangle(disp,win,color_gc,x,y,w,h);

		len = strlen(xtext_color[color_no]);
		XTextExtents(fs,xtext_color[color_no],len,&dir,&as,&ds,&cs);
		w = cs.rbearing - cs.lbearing;
		h = cs.ascent + cs.descent;

		x = width/2;
		y = height/2 + h + 2;
		XDrawString(disp,win,gc,x,y,xtext_color[color_no],len);

	}else if(type == XJP_CHA || type == XJP_INT){
		char str[10];

		if(type == XJP_CHA){
			sprintf(str,"        %s     key  ",xtext_key[color_no]);
		}else if(type == XJP_INT){
			sprintf(str,"        %s     pix  ",xtext_num[color_no]);
		}

		len = strlen(str);
		XTextExtents(fs,str,len,&dir,&as,&ds,&cs);
		w = cs.rbearing - cs.lbearing;
		h = cs.ascent + cs.descent;

		x = (width - w) / 2;
		y = height/2 + h + 2;
		XDrawImageString(disp,win,gc,x,y,str,len);
	}
}
char * xtext_Selector_Window(char *select_string,int type)
{
	font_select_t fsel = {{0,0,0,0,0,0,0}}; 
	int fw = 0;

	Display *disp;
	Window root,win;
	Colormap cmap;

	XFontStruct *fs;
	GC gc;
	GC color_gc;
	XColor fg0,fg1;
	XColor bg0,bg1;
	XColor rg0,rg1;

	XEvent event;
	KeySym keysym;

	XFontStruct *fs_s;
	xtext_font_t *f_head = NULL, *f_tail = NULL;
	char **xlfd_str;
	int xlfd_max;

	int DW,DH,width,height;
	int select_no = 0;
	int loop = 1;
	int i;

	disp = XOpenDisplay(NULL);
	root = DefaultRootWindow(disp);
	cmap = DefaultColormap(disp,0);
	gc = XCreateGC(disp,root,0,0);
	color_gc = XCreateGC(disp,root,0,0);
	fs = XLoadQueryFont(disp,"-*-*-medium-*-*-*-14-*-*-*-*-*-iso8859-*");

	XAllocNamedColor(disp,cmap,"Navy",&fg1,&fg0);
	XAllocNamedColor(disp,cmap,"lavender",&bg1,&bg0);
	XAllocNamedColor(disp,cmap,"snow",&rg1,&rg0);

	DW = DisplayWidth(disp,0);
	DH = DisplayHeight(disp,0);

	width = 320;
	height = 50;

	XSetFont(disp,gc,fs->fid);
	XSetForeground(disp,gc,fg1.pixel);
	XSetBackground(disp,gc,rg1.pixel);
	win = XCreateSimpleWindow(disp,root,0,0,width,height,0,fg1.pixel,bg1.pixel);
	XSelectInput(disp,win,ExposureMask|KeyPressMask);
	XMapWindow(disp,win);

	if(type == XJP_COL){
		XStoreName(disp,win,"XJP Color Selector");
	}else if(type == XJP_CHA){
		XStoreName(disp,win,"XJP Function_Key Selector");
	}else if(type == XJP_INT){
		XStoreName(disp,win,"XJP Number_Key Selector");
	}else if(type == XJP_FONT){
		char temp[50];

		width = 550;
		height = 100;
		XResizeWindow(disp,win,width,height);

		fs_s = XLoadQueryFont(disp,"-*-*-*-*-*-*-16-*-*-*-*-*-iso8859-*");
		XSetFont(disp,color_gc,fs_s->fid);
		XSetForeground(disp,color_gc,fg1.pixel);
		XSetBackground(disp,color_gc,rg1.pixel);

		xlfd_str = (char **)XListFonts(disp,"-*-*-*-*-*--*-*-*-*-*-*-*-*",99999,&xlfd_max);
		for(i=0;i<xlfd_max;i++){
			xtext_xlfd_create(&f_head,&f_tail,*(xlfd_str+i));
		}
		sprintf(temp,"XJP X-Font Selector  (%d)",xlfd_max);
		XStoreName(disp,win,temp);
	}

	while(loop){
		usleep(500);
		XNextEvent(disp,&event);

		switch(event.type){
			case Expose:
				if(type == XJP_FONT){
					_draw_window_font(disp,win,gc,color_gc,fs,fs_s,width,height,f_head,fsel,fw);
				}else{
					_draw_window(disp,win,gc,color_gc,cmap,fs,width,height,select_no,type);
				}
			break;
			case KeyPress:
				keysym = XLookupKeysym(&event.xkey,0);
				switch(keysym){
					case XK_Return:
						if(type == XJP_COL){
							strcpy(select_string,xtext_color[select_no]);
						}else if(type == XJP_CHA){
							strcpy(select_string,xtext_key[select_no]);
						}else if(type == XJP_INT){
							*select_string = (int )atoi(xtext_num[select_no]);
						}else if(type == XJP_FONT){
							_get_font_select(select_string,f_head,fsel);
						}

						loop = 0;
					break;
					case XK_q:
						loop = 0;
					break;
					case XK_Up:
						if(type == XJP_FONT){
							if(fsel.point[fw]-- <= 0) fsel.point[fw] = 0;
							_set_font_no(&fsel,fw);
							_draw_window_font(disp,win,gc,color_gc,fs,fs_s,width,height,f_head,fsel,fw);
						}else{
							select_no--;
							if(select_no <= 0) select_no=0;
							_draw_window(disp,win,gc,color_gc,cmap,fs,width,height,select_no,type);
						}
					break;
					case XK_Down:
						if(type == XJP_FONT){
							fsel.point[fw]++;
							_set_font_no(&fsel,fw);
							if(_draw_window_font(disp,win,gc,color_gc,fs,fs_s,width,height,f_head,fsel,fw) == 0){
								fsel.point[fw]--;
							}
						}else{
							select_no++;
							if(type == XJP_COL){
								if(xtext_color[select_no] == NULL)select_no--;
							}else if(type == XJP_CHA){
								if(xtext_key[select_no] == NULL) select_no--;
							}else if(type == XJP_INT){
								if(xtext_num[select_no] == NULL) select_no--;
							}
							_draw_window(disp,win,gc,color_gc,cmap,fs,width,height,select_no,type);
						}

					break;
					case XK_Tab:
						if(type == XJP_FONT){
							if(fw++ >= (2+TRUE_TYPE)) fw = 0;
							_draw_window_font(disp,win,gc,color_gc,fs,fs_s,width,height,f_head,fsel,fw);
						}
					break;
				}
			break;
		}

	}
	XDestroyWindow(disp,win);
	XFlush(disp);

	XCloseDisplay(disp);

	if(type == XJP_COL){
		return xtext_color[select_no];
	}else if(type == XJP_CHA){
		return xtext_key[select_no];
	}else if(type == XJP_INT){
		return xtext_num[select_no];
	}else if(type == XJP_FONT){
		xtext_xlfd_free(f_head);
		return NULL;
	}
}

